//+------------------------------------------------------------------+
//|                                                   ma crosses.mq4 |
//+------------------------------------------------------------------+

#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1  clrBlue
#property indicator_color2  clrRed

//
//
//
//
//

extern int                FastMa             = 13;
extern ENUM_MA_METHOD     FastMAMethod       = MODE_EMA;
extern ENUM_APPLIED_PRICE FastMAPrice        = PRICE_CLOSE;
extern int                SlowMa             = 68;
extern ENUM_MA_METHOD     SlowMAMethod       = MODE_EMA;
extern ENUM_APPLIED_PRICE SlowMAPrice        = PRICE_CLOSE;
extern int                StoKPeriod         = 14;
extern int                StoDPeriod         = 3;
extern int                StoSlowing         = 3;
extern ENUM_STO_PRICE     PriceField         = 0;
extern ENUM_MA_METHOD     SignalMode         = MODE_SMA;

extern bool               alertsOn           = true;
extern bool               alertsOnEveryBreak = false;
extern bool               alertsOnCurrent    = true;
extern bool               alertsMessage      = true;
extern bool               alertsSound        = true;
extern bool               alertsEmail        = false;
extern bool               alertsNotify       = false;

extern double             arrowsDisplacement = 0.5;

//
//
//
//
//

double CrossUp[];
double CrossDn[];
double trend[];

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int init()
{
   IndicatorBuffers(3);   
   SetIndexBuffer(0,CrossUp); SetIndexStyle(0,DRAW_ARROW); SetIndexArrow(0,233);
   SetIndexBuffer(1,CrossDn); SetIndexStyle(1,DRAW_ARROW); SetIndexArrow(1,234); 
   SetIndexBuffer(2,trend);
   
return(0);
}

int deinit() {  return(0); }

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//

int start() {
   int counted_bars=IndicatorCounted();
   int i,limit;

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit = MathMin(Bars-counted_bars,Bars-1);
         
   //
   //
   //
   //
   //
            
   for(i=limit; i>=0; i--)
   {
      double fastMA = iMA(NULL,0,FastMa,0,FastMAMethod,FastMAPrice,i);
      double slowMA = iMA(NULL,0,SlowMa,0,SlowMAMethod,SlowMAPrice,i);
      double sto    = iStochastic(NULL,0,StoKPeriod,StoDPeriod,StoSlowing,SignalMode,PriceField,MODE_MAIN,i);
      double gap    = iATR(NULL,0,20,i); 
      
         if (alertsOnEveryBreak)
              trend[i] = 0;
         else trend[i] = trend[i+1];
          
         if (fastMA>slowMA && sto<20) trend[i] = 1;
         if (fastMA<slowMA && sto>80) trend[i] =-1;

         //
         //
         //
         //
         //
      
         CrossUp[i] = EMPTY_VALUE;
         CrossDn[i] = EMPTY_VALUE;
         if (trend[i]!= trend[i+1] && trend[i]!=0)
         if (trend[i] == 1)
               CrossUp[i] = Low[i]  - arrowsDisplacement * gap;
         else  CrossDn[i] = High[i] + arrowsDisplacement * gap; 
   }
   
   //
   //
   //
   //
   //
         
   if (alertsOn)
   {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1;
      if (trend[whichBar] != trend[whichBar+1])
      if (trend[whichBar] == 1)
            doAlert("crossed up");
      else  doAlert("crossed down");       
   }
return(0);
}

//+------------------------------------------------------------------+
//
//
//
//

void doAlert(string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
      if (previousAlert != doWhat || previousTime != Time[0]) {
          previousAlert  = doWhat;
          previousTime   = Time[0];

          //
          //
          //
          //
          //

          message =  StringConcatenate(Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," ma + stochastic ",doWhat);
             if (alertsMessage) Alert(message);
             if (alertsNotify)  SendNotification(message);
             if (alertsEmail)   SendMail(StringConcatenate(Symbol()," ma + stochastic "),message);
             if (alertsSound)   PlaySound("alert2.wav");
      }
}

